unit UDataMoudle;

interface

uses
  Windows, Messages, SysUtils, Classes, ComServ, ComObj, VCLCom, DataBkr,
  DBClient, DateServe_TLB, StdVcl, Provider, Db, DBISAMTb,registry;

type
  TDateReportServer = class(TRemoteDataModule, IDateReportServer)
    DataBase: TDBISAMDatabase;
    QryReadData: TDBISAMQuery;
    DSPserverData: TDataSetProvider;
    insertQuery: TDBISAMQuery;
    procedure DataBaseBeforeConnect(Sender: TObject);
    procedure RemoteDataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  protected
    class procedure UpdateRegistry(Register: Boolean; const ClassID, ProgID: string); override;

    procedure preSQL; safecall;
    procedure CommitInsert; safecall;
    procedure starttran; safecall;
    procedure InsertData(const Param1, Param2, Param3, Param4, Param5, Param6,
      Param7, Param8, Param9, Param10: WideString); safecall;
    procedure Deldata(const Years, Months, Dates, times, items: WideString);
      safecall;
  public
    { Public declarations }
  end;

implementation

uses UserverFrm;

{$R *.DFM}


class procedure TDateReportServer.UpdateRegistry(Register: Boolean; const ClassID, ProgID: string);
begin
  if Register then
  begin
    inherited UpdateRegistry(Register, ClassID, ProgID);
    EnableSocketTransport(ClassID);
    EnableWebTransport(ClassID);
  end else
  begin
    DisableSocketTransport(ClassID);
    DisableWebTransport(ClassID);
    inherited UpdateRegistry(Register, ClassID, ProgID);
  end;
end;

procedure TDateReportServer.DataBaseBeforeConnect(Sender: TObject);
begin
end;
                           //RemoteDataModuleCreate
procedure TDateReportServer.RemoteDataModuleCreate(Sender: TObject);
var
  RegDir : string ;
begin

  with TRegistry.Create do
  begin
    try
      RootKey := HKEY_CURRENT_USER;
      if KeyExists('\Software\DateReport') then
      begin
         if OpenKey('\Software\DateReport',True) then
          regDir := ReadString('DataBaseDir');
         DateServerFrm.Label2.Caption := 'Ʈw|DataRe G'+regDir;
      end ;
     finally
       CloseKey;
       Free;
     end;
  end ;
  DataBase.Directory := RegDir ;
end;


procedure TDateReportServer.preSQL;
begin
  DateServerFrm.Label3.Visible := True ;
  DateServerFrm.DataToClient := 0 ;
  with insertQuery do
  begin
     Active := False ;
     SQL.Clear ;
     SQL.Add('insert into record ');
     SQL.Add('(years,Months,Dates,times,mainitems,Record,other,startAlm,endAlm,isImpot) ');
     SQL.Add(' values ');
     SQL.Add('(:years,:Months,:Dates,:times,:mainitems,:Record,:other,:startAlm,:endAlm,:isImpot) ');
  end;
  DateServerFrm.Label3.Caption := 'IS propare' ;
end;

procedure TDateReportServer.CommitInsert;
begin

  try
    DataBase.Commit ;
    DateServerFrm.Label3.Caption := 'IS Comit' ;
    DateServerFrm.Label3.Visible := False ;
  except
    DataBase.Rollback ;
    DateServerFrm.Label3.Caption := 'IS RollBack' ;
  end;
end;

procedure TDateReportServer.starttran;
begin
   if not DataBase.InTransaction then
     DataBase.StartTransaction ;
    DateServerFrm.Label3.Caption := 'IS StartTransaction' ;
end;


procedure TDateReportServer.InsertData(const Param1, Param2, Param3,
  Param4, Param5, Param6, Param7, Param8, Param9, Param10: WideString);
begin
  with insertQuery do
  begin
     Active := False ;
     Params[0].AsString := param1 ;
     Params[1].AsString := param2 ;
     Params[2].AsString := param3 ;
     Params[3].AsString := param4 ;
     Params[4].AsString := param5 ;
     Params[5].AsMemo   := param6 ;
     Params[6].AsString := param7 ;
     Params[7].AsString := param8 ;
     Params[8].AsString := param9 ;
     Params[9].AsString := param10 ;
     ExecSQL ;
  end;
  DateServerFrm.DataToClient := DateServerFrm.DataToClient + 1 ;
  DateServerFrm.Label3.Caption := 'U : '+inttostr(DateServerFrm.DataToClient)+' ';
end;

procedure TDateReportServer.Deldata(const Years, Months, Dates, times,
  items: WideString);
begin
  try
    if not Database.InTransaction then
      Database.StartTransaction ;

    with insertQuery do
    begin
       Active := False ;
       SQL.Clear ;
       SQL.text := 'delete from record '+
                   'where years='+years+' and Months ='+Months+' and Dates='+dates+
                   ' and Times='+Times+' and Mainitems ="'+items+'"';
       ExecSQL;
     end ;

     Database.Commit ;
  except
     Database.Rollback ;


  end;
  DateServerFrm.Label3.Caption := 'IS DeleteData.. ing' ;
end;

initialization
  TComponentFactory.Create(ComServer, TDateReportServer,
    Class_DateReportServer, ciMultiInstance, tmApartment);
end.
